﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI.WebControls;

public partial class RealexRedirect : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //format the date expected by Realex
        string timestamp = RealexDateFormatter.DateFormatForRealex();

        //generate the order number
        System.Random RandNum = new System.Random();
        int randomnum = RandNum.Next(1, 1000);
        string orderid = timestamp + "-" + randomnum;

        //take the MerchantID and Shared Secret from the web.config
        string merchantid = WebsiteSettings.RealexMerchantID;
        string secret = WebsiteSettings.RealexSharedSecret;

        //grab the amount of this order from the previous page
        //you might want to use a session instead of Request.Form depending on your setup.
        string curr = "EUR";
        string amount = Request.Form["AmountForRealex"];

        //generate the SHA1
        string temp1 = FormsAuthentication.HashPasswordForStoringInConfigFile(timestamp + "." + merchantid + "." + orderid + "." + amount + "." + curr, "sha1");
        temp1 = temp1.ToLower();
        string temp2 = temp1 + "." + secret;
        string sha1hash = FormsAuthentication.HashPasswordForStoringInConfigFile(temp2, "sha1");
        sha1hash = sha1hash.ToLower();

        //Put values into form fields
        MERCHANT_ID.Text = "<input type=\"hidden\" name=\"MERCHANT_ID\" value=\"" + merchantid + "\" />";
        ORDER_ID.Text = "<input type=\"hidden\" name=\"ORDER_ID\" value=\"" + orderid + "\" />";
        CURRENCY.Text = "<input type=\"hidden\" name=\"CURRENCY\" value=\"" + curr + "\" />";
        AMOUNT.Text = "<input type=\"hidden\" name=\"AMOUNT\" value=\"" + amount + "\" />";
        TIMESTAMP.Text = "<input type=\"hidden\" name=\"TIMESTAMP\" value=\"" + timestamp + "\" />";
        SHA1HASH.Text = "<input type=\"hidden\" name=\"SHA1HASH\" value=\"" + sha1hash + "\" />";
    }
}
