﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI.WebControls;

public partial class RealexResponse : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //get values from Realex
        string timestamp = Request.Form["TIMESTAMP"];
        string result = Request.Form["RESULT"];
        string orderid = Request.Form["ORDER_ID"];
        string message = Request.Form["MESSAGE"];
        string authcode = Request.Form["AUTHCODE"];
        string pasref = Request.Form["PASREF"];
        string sha1hash = Request.Form["SHA1HASH"];
        string AMOUNT = Request.Form["AMOUNT"];
        string CURRENCY = Request.Form["CURRENCY"];
        string merchantid = WebsiteSettings.RealexMerchantID;
        string secret = WebsiteSettings.RealexSharedSecret;

        //generate the SHA1 based on the values provided
        string temp1 = FormsAuthentication.HashPasswordForStoringInConfigFile(timestamp + "." + merchantid + "." + orderid + "." + result + "." + message + "." + pasref + "." + authcode, "sha1");
        temp1 = temp1.ToLower();
        string temp2 = temp1 + "." + secret;
        string hash = FormsAuthentication.HashPasswordForStoringInConfigFile(temp2, "sha1");
        hash = hash.ToLower();

        //Check to see if hashes match
        if (hash != sha1hash) 
        {
            HeaderText.Text = "Internal Error.";
            bodyText.Text = "The response did not authenticate.";
        }

        //continue if everything ok, else tell user something happened
        if (result == "00")
        {
            HeaderText.Text = "Your order completed successfully!";
            bodyText.Text = "Thank you very much for your order.";

            //now that we know credit card was successful, do whatever else we need to - put in your own logic here
            ProcessTransaction();
        }
        else
        {
            HeaderText.Text = "There was an error with your card.";
            bodyText.Text = "The error returned was: " + result;
        }
    }

    protected void ProcessTransaction()
    {
        //put in your code for saving order to your database
        //email customer their order details
        //email website admin that order was made and to process it
    }
}